OpenTTD Source: src/tile_map.h File Reference

OpenTTD Source 12.0-beta1

Functions
tile_map.h File Reference
`#include "slope_type.h"`
`#include "map_func.h"`
`#include "core/bitmath_func.hpp"`
`#include "settings_type.h"`

Go to the source code of this file.

## Functions
static uint | TileHeight (TileIndex tile)
| Returns the height of a tile. More...
static uint | TileHeightOutsideMap (int x, int y)
| Returns the height of a tile, also for tiles outside the map (virtual "black" tiles). More...
static void | SetTileHeight (TileIndex tile, uint height)
| Sets the height of a tile. More...
static uint | TilePixelHeight (TileIndex tile)
| Returns the height of a tile in pixels. More...
static uint | TilePixelHeightOutsideMap (int x, int y)
| Returns the height of a tile in pixels, also for tiles outside the map (virtual "black" tiles). More...
static TileType | GetTileType (TileIndex tile)
| Get the tiletype of a given tile. More...
static bool | IsInnerTile (TileIndex tile)
| Check if a tile is within the map (not a border) More...
static void | SetTileType (TileIndex tile, TileType type)
| Set the type of a tile. More...
static bool | IsTileType (TileIndex tile, TileType type)
| Checks if a tile is a given tiletype. More...
static bool | IsValidTile (TileIndex tile)
| Checks if a tile is valid. More...
static Owner | GetTileOwner (TileIndex tile)
| Returns the owner of a tile. More...
static void | SetTileOwner (TileIndex tile, Owner owner)
| Sets the owner of a tile. More...
static bool | IsTileOwner (TileIndex tile, Owner owner)
| Checks if a tile belongs to the given owner. More...
static void | SetTropicZone (TileIndex tile, TropicZone type)
| Set the tropic zone. More...
static TropicZone | GetTropicZone (TileIndex tile)
| Get the tropic zone. More...
static byte | GetAnimationFrame (TileIndex t)
| Get the current animation frame. More...
static void | SetAnimationFrame (TileIndex t, byte frame)
| Set a new animation frame. More...
Slope | GetTileSlope (TileIndex tile, int *h=nullptr)
| Return the slope of a given tile inside the map. More...
int | GetTileZ (TileIndex tile)
| Get bottom height of the tile. More...
int | GetTileMaxZ (TileIndex tile)
| Get top height of the tile inside the map. More...
bool | IsTileFlat (TileIndex tile, int *h=nullptr)
| Check if a given tile is flat. More...
static Slope | GetTilePixelSlope (TileIndex tile, int *h)
| Return the slope of a given tile. More...
Slope | GetTilePixelSlopeOutsideMap (int x, int y, int *h)
| Return the slope of a given tile, also for tiles outside the map (virtual "black" tiles). More...
static int | GetTilePixelZ (TileIndex tile)
| Get bottom height of the tile. More...
static int | GetTileMaxPixelZ (TileIndex tile)
| Get top height of the tile. More...
static uint | TileHash (uint x, uint y)
| Calculate a hash value from a tile position. More...
static uint | TileHash2Bit (uint x, uint y)
| Get the last two bits of the TileHash from a tile position. More...

## Detailed Description

Map writing/reading functions for tiles.

Definition in file tile_map.h.

## Function Documentation

## ◆ GetAnimationFrame()

static byte GetAnimationFrame | ( | TileIndex | t | ) |
| inlinestatic

Get the current animation frame.

Parameters

  t | the tile

Precondition
  IsTileType(t, MP_HOUSE) || IsTileType(t, MP_OBJECT) || IsTileType(t, MP_INDUSTRY) ||IsTileType(t, MP_STATION)

Returns
  frame number

Definition at line 250 of file tile_map.h.

References _me, IsTileType(), TileExtended::m7, MP_HOUSE, MP_INDUSTRY, MP_OBJECT, and MP_STATION.

Referenced by AnimationBase< IndustryAnimationBase, IndustryTileSpec, Industry, int, GetSimpleIndustryCallback >::AnimateTile(), IndustryTileScopeResolver::GetVariable(), AirportTileScopeResolver::GetVariable(), ObjectScopeResolver::GetVariable(), and IncreaseAnimationStage().

## ◆ GetTileMaxPixelZ()

static int GetTileMaxPixelZ | ( | TileIndex | tile | ) |
| inlinestatic

Get top height of the tile.

Parameters

  tile | Tile to compute height of

Returns
  Maximum height of the tile

Definition at line 304 of file tile_map.h.

References GetTileMaxZ(), and TILE_HEIGHT.

Referenced by EnsureNoVehicleOnGround().

## ◆ GetTileMaxZ()

int GetTileMaxZ | ( | TileIndex | t | ) |

Get top height of the tile inside the map.

Parameters

  t | Tile to compute height of

Returns
  Maximum height of the tile

Definition at line 141 of file tile_map.cpp.

References MapMaxX(), MapMaxY(), TileHeight(), TileX(), TileXY(), and TileY().

Referenced by AutoslopeCheckForEntranceEdge(), BuildTownHouse(), CheckBuildHouseSameZ(), DrawRoadTypeCatenary(), FloodVehicleProc(), GetOtherAqueductEnd(), GetTileMaxPixelZ(), and ShipTestUpDownOnLock().

## ◆ GetTileOwner()

static Owner GetTileOwner | ( | TileIndex | tile | ) |
| inlinestatic

Returns the owner of a tile.

This function returns the owner of a tile. This cannot used for tiles which type is one of MP_HOUSE, MP_VOID and MP_INDUSTRY as no company owned any of these buildings.

Parameters

  tile | The tile to check

Returns
  The owner of the tile

Precondition
  IsValidTile(tile)
  The type of the tile must not be MP_HOUSE and MP_INDUSTRY

Definition at line 178 of file tile_map.h.

References _m, GB(), IsTileType(), IsValidTile(), MP_HOUSE, and MP_INDUSTRY.

Referenced by AfterLoadCompanyStats(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::CanEnterNewTile(), CheckTileOwnership(), CmdConvertRail(), FixOwnerOfRailTrack(), GetMinimapOwner(), GetTrainForReservation(), ObjectScopeResolver::GetVariable(), IsTileOwner(), MakeBuoy(), MakeLock(), MoveBuoysToWaypoints(), RemoveLock(), and UpdateObjectColours().

## ◆ GetTilePixelSlope()

static Slope GetTilePixelSlope | ( | TileIndex | tile,
|  | int * | h
| ) |  |
| inlinestatic

Return the slope of a given tile.

Parameters

  tile | Tile to compute slope of
  h | If not `nullptr`, pointer to storage of z height

Returns
  Slope of the tile, except for the HALFTILE part

Definition at line 280 of file tile_map.h.

References GetTileSlope(), and TILE_HEIGHT.

Referenced by GetNearbyTileInformation().

## ◆ GetTilePixelSlopeOutsideMap()

Slope GetTilePixelSlopeOutsideMap | ( | int | x,
|  | int | y,
|  | int * | h
| ) |  |

Return the slope of a given tile, also for tiles outside the map (virtual "black" tiles).

Parameters

  x | X coordinate of the tile to compute slope of, may be outside the map.
  y | Y coordinate of the tile to compute slope of, may be outside the map.
  h | If not `nullptr`, pointer to storage of z height.

Returns
  Slope of the tile, except for the HALFTILE part.

Definition at line 82 of file tile_map.cpp.

## ◆ GetTilePixelZ()

static int GetTilePixelZ | ( | TileIndex | tile | ) |
| inlinestatic

Get bottom height of the tile.

Parameters

  tile | Tile to compute height of

Returns
  Minimum height of the tile

Definition at line 294 of file tile_map.h.

References GetTileZ(), and TILE_HEIGHT.

## ◆ GetTileSlope()

Slope GetTileSlope | ( | TileIndex | tile,
|  | int * | h
| ) |  |

Return the slope of a given tile inside the map.

Parameters

  tile | Tile to compute slope of
  h | If not `nullptr`, pointer to storage of z height

Returns
  Slope of the tile, except for the HALFTILE part

Definition at line 59 of file tile_map.cpp.

References GetTileSlopeGivenHeight(), MapMaxX(), MapMaxY(), TileHeight(), TileX(), TileXY(), and TileY().

Referenced by BuildTownHouse(), CanBuildHouseHere(), CanPlantTreesOnTile(), CheckBuildableTile(), CheckIfIndustryTilesAreFree(), CmdBuildLock(), CmdBuildRoadDepot(), CmdBuildTrainDepot(), FlowsDown(), GetBridgeHeight(), GetFloodingBehaviour(), GetFoundationSlope(), GetOtherAqueductEnd(), GetTilePixelSlope(), StationScopeResolver::GetVariable(), ObjectScopeResolver::GetVariable(), GrowTownWithBridge(), GrowTownWithTunnel(), BuildDocksToolbarWindow::OnPlacePresize(), PerformStationTileSlopeCheck(), SearchTileForStatue(), ShipTestUpDownOnLock(), and CYapfCostBase::stSlopeCost().

## ◆ GetTileType()

static TileType GetTileType | ( | TileIndex | tile | ) |
| inlinestatic

Get the tiletype of a given tile.

Parameters

  tile | The tile to get the TileType

Returns
  The tiletype of the tile

Precondition
  tile < MapSize()

Definition at line 96 of file tile_map.h.

References _m, GB(), and MapSize().

Referenced by AfterLoadCompanyStats(), CanEnterTileOwnerCheck(), CanFollowRoad(), CanPlantTreesOnTile(), ChangeTileOwner(), CheckIfFarEnoughFromConflictingIndustry(), CleanUpRoadBits(), ClosestTownFromTile(), CmdConvertRail(), DrawRailCatenary(), GetAnyRoadBits(), GetDepotVehicleType(), GetFloodingBehaviour(), GetFoundationSlope(), GetGrfSpecFeature(), GetMinimapOwner(), GetNearbyTileInformation(), GetRailTrackBitsUniversal(), GetReservedTrackbits(), SmallMapWindow::GetTileColours(), GetTileRailType(), GetTileTrackStatus(), GrowTownWithExtraHouse(), Depot::IsOfType(), IsSuitableForFarmField(), IsTileType(), IsWateredTile(), MayHaveRoad(), CYapfCostRoadT< Types >::OneTileCost(), CYapfCostRailT< Types >::OneTileCost(), PlantTreesOnTile(), SetWaterClassDependingOnSurroundings(), TryReserveRailTrack(), UnreserveRailTrack(), UpdateSignalsInBuffer(), and Town::~Town().

## ◆ GetTileZ()

int GetTileZ | ( | TileIndex | tile | ) |

Get bottom height of the tile.

Parameters

  tile | Tile to compute height of

Returns
  Minimum height of the tile

Definition at line 121 of file tile_map.cpp.

References MapMaxX(), MapMaxY(), TileHeight(), TileX(), TileXY(), and TileY().

Referenced by CheckNewIndustry_BubbleGen(), GetOtherTunnelEnd(), GetTilePixelZ(), CanalScopeResolver::GetVariable(), IndustriesScopeResolver::GetVariable(), GrowTownWithTunnel(), IsTunnelInWayDir(), ShipTestUpDownOnLock(), and TileLoopClearAlps().

## ◆ GetTropicZone()

static TropicZone GetTropicZone | ( | TileIndex | tile | ) |
| inlinestatic

Get the tropic zone.

Parameters

  tile | the tile to get the zone of

Precondition
  tile < MapSize()

Returns
  the zone type

Definition at line 238 of file tile_map.h.

References _m, GB(), and MapSize().

Referenced by CheckNewIndustry_Lumbermill(), CheckNewIndustry_Plantation(), CheckNewIndustry_Water(), NeighbourIsNormal(), and RiverModifyDesertZone().

## ◆ IsInnerTile()

static bool IsInnerTile | ( | TileIndex | tile | ) |
| inlinestatic

Check if a tile is within the map (not a border)

Parameters

  tile | The tile to check

Returns
  Whether the tile is in the interior of the map

Precondition
  tile < MapSize()

Definition at line 109 of file tile_map.h.

References MapSize().

Referenced by SetTileType(), and TgenSetTileHeight().

## ◆ IsTileFlat()

bool IsTileFlat | ( | TileIndex | tile,
|  | int * | h
| ) |  |

Check if a given tile is flat.

Parameters

  tile | Tile to check
  h | If not `nullptr`, pointer to storage of z height (only if tile is flat)

Returns
  Whether the tile is flat

Definition at line 100 of file tile_map.cpp.

References MapMaxX(), MapMaxY(), TileHeight(), TileX(), TileXY(), and TileY().

Referenced by CheckIfIndustryTilesAreFree(), CmdBuildBuoy(), CmdBuildShipDepot(), FindFurthestFromWater(), FindSpring(), MakeLake(), SetWaterClassDependingOnSurroundings(), TownCanBePlacedHere(), and TryBuildTransmitter().

## ◆ IsTileOwner()

static bool IsTileOwner | ( | TileIndex | tile,
|  | Owner | owner
| ) |  |
| inlinestatic

Checks if a tile belongs to the given owner.

Parameters

  tile | The tile to check
  owner | The owner to check against

Returns
  True if a tile belongs the the given owner

Definition at line 214 of file tile_map.h.

References GetTileOwner().

Referenced by CanEnterTileOwnerCheck(), CmdBuildVehicle(), CmdDepotMassAutoReplace(), DoClearBridge(), DoClearTunnel(), GetOrderCmdFromTile(), and TestTownOwnsBridge().

## ◆ IsTileType()

static bool IsTileType | ( | TileIndex | tile,
|  | TileType | type
| ) |  |
| inlinestatic

Checks if a tile is a given tiletype.

This function checks if a tile has the given tiletype.

Parameters

  tile | The tile to check
  type | The type to check against

Returns
  true If the type matches against the type of the tile

Definition at line 150 of file tile_map.h.

References GetTileType().

Referenced by AddClearCounter(), AddClearDensity(), AddTreeCount(), AddTreeCounter(), AddTreeGrowth(), AdjustTileh(), AmbientSoundEffectCallback(), Vehicle::BeginLoading(), CanEnterTile(), CanEnterTileOwnerCheck(), Station::CatchmentCoversTown(), CheckFlatLandRailStation(), CheckFlatLandRoadStop(), CheckForDockingTile(), CheckSubsidised(), ClearPathReservation(), CmdBuildLongRoad(), CmdTerraformLand(), CMSAMine(), CMSATree(), CMSAWater(), Train::Crash(), DecHouseProcessingTime(), DoClearTownHouseHelper(), DoFloodTile(), DoTriggerIndustryTile(), DrawRoadCatenary(), ExtendTrainReservation(), FindFurthestFromWater(), FindNearestEmptyLand(), FindNearIndustryName(), FindRailStationEnd(), FindSubsidyCargoDestination(), FindSubsidyTownCargoRoute(), FollowReservation(), CFollowTrackT< Ttr_type_, VehicleType, T90deg_turns_allowed_, Tmask_reserved_tracks >::FollowTileExit(), FollowTrainReservation(), ForAllStationsAroundTiles(), FreeTrainTrackReservation(), GetAcceptanceAroundTiles(), GetAnimationFrame(), GetAxisForNewWaypoint(), GetCleanHouseType(), GetCleanIndustryGfx(), GetClearCounter(), GetClearDensity(), GetDockOffset(), GetEffectiveWaterClass(), GetHouseAge(), GetHouseBuildingStage(), GetHouseConstructionTick(), GetHouseProcessingTime(), GetHouseRandomBits(), GetHouseTriggers(), GetIndustryAnimationLoop(), GetIndustryConstructionCounter(), GetIndustryConstructionStage(), GetIndustryGfx(), GetIndustryIndex(), GetIndustryRandomBits(), GetIndustryTriggers(), GetIndustryType(), GetMinimapOwner(), GetNearbyAirportTileInformation(), GetNearbyIndustryTileInformation(), GetNearbyObjectTileInformation(), GetNearbyTileInformation(), GetObjectIDAtOffset(), GetObjectIndex(), GetObjectRandomBits(), GetObjectType(), GetOrderCmdFromTile(), GetOtherTunnelBridgeEnd(), GetProductionAroundTiles(), GetRailTileType(), CanalScopeResolver::GetRandomBits(), HouseScopeResolver::GetRandomBits(), ObjectScopeResolver::GetRandomBits(), GetRawClearGround(), GetRoadTileType(), GetStationGfx(), GetStationIndex(), StationFinder::GetStations(), GetStationTileRandomBits(), GetStationType(), GetTileCatchmentRadius(), GetTileHighlightType(), GetTileOwner(), GetTownIndex(), GetTrainForReservation(), GetTreeCount(), GetTreeCounter(), GetTreeDensity(), GetTreeGround(), GetTreeGrowth(), GetTreeType(), HouseScopeResolver::GetTriggers(), GetTunnelBridgeDirection(), GetTunnelBridgeTransportType(), CanalScopeResolver::GetVariable(), IndustryTileScopeResolver::GetVariable(), HouseScopeResolver::GetVariable(), ObjectScopeResolver::GetVariable(), GetWaterTileRandomBits(), GetWaterTileType(), HasOnewaySignalBlockingTrackdir(), HasPbsSignalOnTrackdir(), HasStationTileRail(), HasTileWaterClass(), HasTunnelBridgeReservation(), HasTunnelBridgeSnowOrDesert(), IncHouseConstructionTick(), IncrementHouseAge(), IsAirportTile(), IsBridge(), IsBridgeTile(), IsBuoyTile(), IsCoastTile(), IsDockingTile(), IsDockTile(), RoadStop::IsDriveThroughRoadStopContinuation(), IsHangar(), IsHangarTile(), IsHouseCompleted(), IsIndustryCompleted(), IsLevelCrossingTile(), IsNormalRoadTile(), IsObjectTypeTile(), IsPlainRailTile(), IsPossibleCrossing(), IsRailDepotTile(), IsRailStationTile(), IsRailWaypointTile(), IsRoadDepotTile(), IsRoadStop(), IsRoadStopTile(), IsSafeWaitingPosition(), IsShipDepotTile(), IsShipDestinationTile(), IsSnowTile(), IsTileForestIndustry(), IsTunnel(), IsTunnelTile(), IsValidTile(), IsValidTileForWaypoint(), IsWaitingPositionFree(), IsWaterTile(), MakeHouseTile(), MakeSingleHouseBigger(), MarkTileDirtyIfCanalOrRiver(), MayHaveBridgeAbove(), MoveBuoysToWaypoints(), Station::RecomputeCatchment(), ResetHouseAge(), ResetIndustryConstructionStage(), RoadTypesAllowHouseHere(), StationRect::ScanForStationTiles(), SearchLumberMillTrees(), SearchNearbyHouseClass(), SearchNearbyHouseGRFID(), SearchNearbyHouseID(), SearchTileForStatue(), SetAnimationFrame(), SetClearCounter(), SetClearDensity(), SetClearGroundDensity(), SetDockingTile(), SetHouseCompleted(), SetHouseProcessingTime(), SetHouseRandomBits(), SetHouseTriggers(), SetHouseType(), SetIndustryAnimationLoop(), SetIndustryCompleted(), SetIndustryConstructionCounter(), SetIndustryConstructionStage(), SetIndustryGfx(), SetIndustryRandomBits(), SetIndustryTriggers(), SetStationGfx(), SetStationTileRandomBits(), SetTileOwner(), SetTownIndex(), SetTreeCounter(), SetTreeGroundDensity(), SetTreeGrowth(), SetTropicZone(), SetTunnelBridgeReservation(), SetTunnelBridgeSnowOrDesert(), SetupFarmFieldFence(), ShipTestUpDownOnLock(), TestTownOwnsBridge(), Industry::TileBelongsToIndustry(), TileLoop_Water(), TownCanBePlacedHere(), TrainCanLeaveTile(), TriggerWatchedCargoCallbacks(), TryBuildTransmitter(), UpdateHousesAndTowns(), UpdateNearestTownForRoadTiles(), UpdateStatusAfterSwap(), and WatchedCargoCallback().

## ◆ IsValidTile()

static bool IsValidTile | ( | TileIndex | tile | ) |
| inlinestatic

Checks if a tile is valid.

Parameters

  tile | The tile to check

Returns
  True if the tile is on the map and not one of MP_VOID.

Definition at line 161 of file tile_map.h.

References IsTileType(), MapSize(), and MP_VOID.

Referenced by CalculateCoverageLine(), CanConnectToRoad(), CanFollowRoad(), CheckForDockingTile(), CheckIfIndustryTilesAreFree(), CleanUpRoadBits(), ClearDockingTilesCheckingNeighbours(), CmdBuildBridge(), CmdStoryPageButton(), DisasterTick_Submarine(), DoCommand(), DoTriggerIndustryTile(), DrawTileSelectionRect(), FindDockLandPart(), GetOtherAqueductEnd(), IndustryTileScopeResolver::GetRandomBits(), HouseScopeResolver::GetRandomBits(), ObjectScopeResolver::GetRandomBits(), GetTileOwner(), IndustryTileScopeResolver::GetTriggers(), HouseScopeResolver::GetTriggers(), ObjectScopeResolver::GetVariable(), GrowTownWithBridge(), GrowTownWithTunnel(), GoalListWindow::HandleClick(), IsNeighborRoadTile(), IsShipDestinationTile(), IsTunnelInWayDir(), MakeLake(), MarkTileDirtyIfCanalOrRiver(), NeighbourIsNormal(), RoadTypesAllowHouseHere(), SetTileOwner(), TileLoop_Water(), and VerifyElementContentParameters().

## ◆ SetAnimationFrame()

static void SetAnimationFrame | ( | TileIndex | t,
|  | byte | frame
| ) |  |
| inlinestatic

Set a new animation frame.

Parameters

  t | the tile
  frame | the new frame number

Precondition
  IsTileType(t, MP_HOUSE) || IsTileType(t, MP_OBJECT) || IsTileType(t, MP_INDUSTRY) ||IsTileType(t, MP_STATION)

Definition at line 262 of file tile_map.h.

References _me, IsTileType(), TileExtended::m7, MP_HOUSE, MP_INDUSTRY, MP_OBJECT, and MP_STATION.

Referenced by AnimationBase< IndustryAnimationBase, IndustryTileSpec, Industry, int, GetSimpleIndustryCallback >::ChangeAnimationFrame(), IncreaseAnimationStage(), and MakeHouseTile().

## ◆ SetTileHeight()

static void SetTileHeight | ( | TileIndex | tile,
|  | uint | height
| ) |  |
| inlinestatic

Sets the height of a tile.

This function sets the height of the northern corner of a tile.

Parameters

  tile | The tile to change the height
  height | The new height value of the tile

Precondition
  tile < MapSize()
  height <= MAX_TILE_HEIGHT

Definition at line 57 of file tile_map.h.

References _m, Tile::height, MapSize(), and MAX_TILE_HEIGHT.

Referenced by FlatEmptyWorld(), MakeVoid(), and TgenSetTileHeight().

## ◆ SetTileOwner()

static void SetTileOwner | ( | TileIndex | tile,
|  | Owner | owner
| ) |  |
| inlinestatic

Sets the owner of a tile.

This function sets the owner status of a tile. Note that you cannot set a owner for tiles of type MP_HOUSE, MP_VOID and MP_INDUSTRY.

Parameters

  tile | The tile to change the owner status.
  owner | The new owner.

Precondition
  IsValidTile(tile)
  The type of the tile must not be MP_HOUSE and MP_INDUSTRY

Definition at line 198 of file tile_map.h.

References _m, IsTileType(), IsValidTile(), MP_HOUSE, MP_INDUSTRY, and SB().

Referenced by FixOwnerOfRailTrack(), MakeBridgeRamp(), MakeClear(), MakeField(), MakeLockTile(), MakeObject(), MakeRailTunnel(), MakeRoadCrossing(), MakeRoadDepot(), MakeRoadNormal(), MakeRoadTunnel(), MakeShipDepot(), MakeShore(), MakeStation(), MakeTree(), MakeWater(), and SetTunnelBridgeOwner().

## ◆ SetTileType()

static void SetTileType | ( | TileIndex | tile,
|  | TileType | type
| ) |  |
| inlinestatic

Set the type of a tile.

This functions sets the type of a tile. If the type MP_VOID is selected the tile must be at the south-west or south-east edges of the map and vice versa.

Parameters

  tile | The tile to save the new type
  type | The type to save

Precondition
  tile < MapSize()
  type MP_VOID <=> tile is on the south-east or south-west edge.

Definition at line 131 of file tile_map.h.

References _m, IsInnerTile(), MapSize(), MP_VOID, and SB().

Referenced by MakeBridgeRamp(), MakeClear(), MakeField(), MakeHouseTile(), MakeIndustry(), MakeLockTile(), MakeObject(), MakeRailTunnel(), MakeRoadCrossing(), MakeRoadDepot(), MakeRoadNormal(), MakeRoadTunnel(), MakeShipDepot(), MakeShore(), MakeStation(), MakeTree(), MakeVoid(), and MakeWater().

## ◆ SetTropicZone()

static void SetTropicZone | ( | TileIndex | tile,
|  | TropicZone | type
| ) |  |
| inlinestatic

Set the tropic zone.

Parameters

  tile | the tile to set the zone of
  type | the new type

Precondition
  tile < MapSize()

Definition at line 225 of file tile_map.h.

References _m, IsTileType(), MapSize(), MP_VOID, SB(), and TROPICZONE_NORMAL.

Referenced by RiverModifyDesertZone().

## ◆ TileHash()

static uint TileHash | ( | uint | x,
|  | uint | y
| ) |  |
| inlinestatic

Calculate a hash value from a tile position.

Parameters

  x | The X coordinate
  y | The Y coordinate

Returns
  The hash of the tile

Definition at line 316 of file tile_map.h.

Referenced by Town::InitializeLayout(), and River_Hash().

## ◆ TileHash2Bit()

static uint TileHash2Bit | ( | uint | x,
|  | uint | y
| ) |  |
| inlinestatic

Get the last two bits of the TileHash from a tile position.

See also
  TileHash()

Parameters

  x | The X coordinate
  y | The Y coordinate

Returns
  The last two bits from hash of the tile

Definition at line 334 of file tile_map.h.

Referenced by HouseScopeResolver::GetVariable().

## ◆ TileHeight()

static uint TileHeight | ( | TileIndex | tile | ) |
| inlinestatic

Returns the height of a tile.

This function returns the height of the northern corner of a tile. This is saved in the global map-array. It does not take affect by any slope-data of the tile.

Parameters

  tile | The tile to get the height from

Returns
  the height of the tile

Precondition
  tile < MapSize()

Definition at line 29 of file tile_map.h.

References _m, Tile::height, and MapSize().

Referenced by CalculateCoverageLine(), CheckIfCanLevelIndustryPlatform(), ClickChangeMaxHlCheat(), CmdLevelLand(), CmdTerraformLand(), FlowRiver(), GetTileHeightBelowAircraft(), GetTileMaxZ(), GetTileSlope(), GetTileZ(), IsTileFlat(), MakeHeightmapScreenshot(), MakeLake(), MarkBridgeDirty(), MarkTileDirtyByTile(), TerraformGetHeightOfTile(), and TilePixelHeight().

## ◆ TileHeightOutsideMap()

static uint TileHeightOutsideMap | ( | int | x,
|  | int | y
| ) |  |
| inlinestatic

Returns the height of a tile, also for tiles outside the map (virtual "black" tiles).

Parameters

  x | X coordinate of the tile, may be outside the map.
  y | Y coordinate of the tile, may be outside the map.

Returns
  The height in the same unit as TileHeight.

Definition at line 42 of file tile_map.h.

## ◆ TilePixelHeight()

static uint TilePixelHeight | ( | TileIndex | tile | ) |
| inlinestatic

Returns the height of a tile in pixels.

This function returns the height of the northern corner of a tile in pixels.

Parameters

  tile | The tile to get the height

Returns
  The height of the tile in pixel

Definition at line 72 of file tile_map.h.

References TILE_HEIGHT, and TileHeight().

## ◆ TilePixelHeightOutsideMap()

static uint TilePixelHeightOutsideMap | ( | int | x,
|  | int | y
| ) |  |
| inlinestatic

Returns the height of a tile in pixels, also for tiles outside the map (virtual "black" tiles).

Parameters

  x | X coordinate of the tile, may be outside the map.
  y | Y coordinate of the tile, may be outside the map.

Returns
  The height in pixels in the same unit as TilePixelHeight.

Definition at line 84 of file tile_map.h.

Referenced by GetViewportY().